#include <stdio.h>
#include <stdlib.h>

typedef struct node
{
  int content; 
  struct node *next;
} node;

node *first = NULL;

void push (int x)
{
  node *n = malloc (sizeof (node));
  n->content = x;
  n->next = NULL;
  if (first)
    {
      if (first->next)
        {
          if (first->next->next)
            first->next->next->next = n;
          else
            first->next->next = n;
        }
      else
        first->next = n;
    }
  else
    first = n;
}

int main (void)
{
  push (3);
  push (7);
  push (137);
  push (1117);
  for (node *p = first; p; p = p->next)
    printf ("%d\n", p->content);
  return 0;
}
