#include <stdio.h>
#include <stdlib.h>

typedef struct node
{
  int content;
  struct node *left, *right;
} node;

node *root = NULL;

void insert (int content)
{
  node *p = malloc (sizeof (node));
  p->content = content;
  p->left = NULL;
  p->right = NULL;
  if (root == NULL)
    root = p;
  else
    {
      node *save_root = root;
      if (content < root->content)
        {
          root = root->left;
          insert (content);
          save_root->left = root;
        }
      else
        {
          root = root->right;
          insert (content);
          save_root->right = root;
        }
      root = save_root;
    }
}

void output (node *root)
{
  if (root)
    {
      output (root->left);
      printf ("%d\n", root->content);
      output (root->right);
    }
  else
    printf ("root is NULL\n");
}

int main (void)
{
  insert (7);
  insert (137);
  insert (3);
  insert (1117);
  insert (42);
  insert (13);
  output (root);
  return 0;
}
