#include <stdio.h>
#include <stdlib.h>

typedef struct node
{
  int content;
  struct node *left, *right;
} node;

node *root = NULL;

node *insert (node *root, int content)
{
  node *p = malloc (sizeof (node));
  p->content = content;
  p->left = NULL;
  p->right = NULL;
  if (root == NULL)
    return p;
  else
    {
      if (content < root->content)
        {
          root->left = insert (root->left, content);
          return root;
        }
      else
        {
          root->right = insert (root->right, content);
          return root;
        }
    }
}

void output (node *root)
{
  if (root)
    {
      output (root->left);
      printf ("%d\n", root->content);
      output (root->right);
    }
}

int main (void)
{
  insert (root, 7);
  insert (root, 137);
  insert (root, 3);
  insert (root, 1117);
  insert (root, 42);
  insert (root, 13);
  output (root);
  return 0;
}
