#include <stdio.h>
#include <stdlib.h>

typedef struct node
{
  int content;
  struct node *left, *right;
} node;

node *root = NULL;

void insert (int content)
{
  node *p = malloc (sizeof (node));
  p->content = content;
  p->left = NULL;
  p->right = NULL;
  if (root == NULL)
    root = p;
  else
    {
      node *save_root = root;
      if (content > root->content)
        {
          root = root->left;
          insert (content);
        }
      else
        {
          root = root->right;
          insert (content);
        }
      root = save_root;
    }
}

void output (void)
{
  if (root)
    {
      if (root->left)
        {
          node *save_root = root;
          root = root->left;
          output ();
          root = save_root;
        }
      printf ("%d\n", root->content);
      if (root->right)
        {
          node *save_root = root;
          root = root->right;
          output ();
          root = save_root;
        }
    }
  else
    printf ("root is NULL\n");
}

int main (void)
{
  insert (7);
  insert (137);
  insert (3);
  insert (1117);
  insert (42);
  insert (13);
  output ();
  return 0;
}
