#include <stdio.h>

typedef struct
{
  int type;
} t_base;

typedef struct
{
  int type;
  int content;
} t_integer;

typedef struct
{
  int type;
  char *content;
} t_string;

void print_object (t_base *this)
{
  if (this->type == 1)
    printf ("Integer: %d\n", ((t_integer *) this)->content);
  else if (this->type == 2)
    printf ("String: \"%s\"\n", ((t_string *) this)->content);
}

int main (void)
{
  t_integer i = { 1, 42 };
  t_string s = { 2, "Hello, world!" };

  t_base *object[] = { (t_base *) &i, (t_base *) &s };

  for (int i = 0; i < 2; i++)
    print_object (object[i]);

  return 0;
}
