#include <stdio.h>

#define FIFO_SIZE 10

int fifo[FIFO_SIZE];
int fifo_read = 0;
int fifo_write = 0;

void push (int x)
{
  fifo[fifo_write++] = x;
  if (fifo_write >= FIFO_SIZE)
    fifo_write = 0;
}

int pop (void)
{
  int result = fifo[fifo_read++];
  if (fifo_read >= FIFO_SIZE)
    fifo_read = 0;
  return result;
}

int main (void)
{
  push (3);
  push (7);
  push (137);
  printf ("%d\n", pop ());
  printf ("%d\n", pop ());
  printf ("%d\n", pop ());
  for (int i = 0; i < 1000; i++)
    {
      push (i);
      printf ("%d\n", pop ());
    }
  return 0;
}
