#include <stdio.h>
#include <stdlib.h>

typedef struct node
{
  int content;
  struct node *left, *right;
} node;

void insert (node **root, int content)
{
  node *p = malloc (sizeof (node));
  p->content = content;
  p->left = NULL;
  p->right = NULL;
  if (*root == NULL)
    *root = p;
  else
    {
      if (content < (*root)->content)
        insert (&(*root)->left, content);
      else
        insert (&(*root)->right, content);
    }
}

void output (node *root)
{
  if (root)
    {
      output (root->left);
      printf ("%d\n", root->content);
      output (root->right);
    }
}

int main (void)
{
  node *root = NULL;
  insert (&root, 7);
  insert (&root, 137);
  insert (&root, 3);
  insert (&root, 1117);
  insert (&root, 42);
  insert (&root, 13);
  output (root);
  return 0;
}
