#include <stdio.h>
#include <stdlib.h>

typedef struct node
{
  int content;
  struct node *left, *right;
} node;

node *root = NULL;

void insert (int content)
{
  node *p = malloc (sizeof (node));
  p->content = content;
  p->left = NULL;
  p->right = NULL;
  if (root == NULL)
    root = p;
  else
    {
      if (content > root->content)
        root->right = p;
      else
        root->left = p;
    }
}

void output (void)
{
  if (root)
    {
      if (root->left)
        printf ("%d\n", root->left->content);
      printf ("%d\n", root->content);
      if (root->right)
        printf ("%d\n", root->right->content);
    }
  else
    printf ("root is NULL\n");
}

int main (void)
{
  insert (7);
  insert (137);
  insert (3);
  output ();
  return 0;
}
