#ifndef TEXTGRAPH_H
#define TEXTGRAPH_H

#define WIDTH 40
#define HEIGHT 20

#define STACK_SIZE 100
#define FIFO_SIZE 100

typedef struct
{
  int x, y;
} pair;

extern void clear (char c);
extern void put_point (int x, int y, char c);
extern char get_point (int x, int y);
extern void fill (int x, int y, char c, char o);
extern void display (void);

extern void clear_display (void);
extern void fill_animated (int x, int y, char c, char o);

extern void stack_push (int x, int y);
extern void stack_pop (int *x, int *y);
extern void fill_stack (int x, int y, char c, char o);

extern void fifo_push (int x, int y);
extern void fifo_pop (int *x, int *y);
extern void fill_fifo (int x, int y, char c, char o);

#endif
